 source file for 3dapp class    
    
   
   
#include stdafx.h    
#include 3dapp.h    
   
struct Initialize   
{   
    Initialize()   
    {   
        CoInitialize( NULL );   
    }   
   
    ~Initialize()   
    {   
        CoUninitialize();   
    }   
};   
   
Initialize ComNowPlease;   
   
   
CNew3dApp g_pApp;   
   
 constructor    
CNew3dAppCNew3dApp()   
{   
    g_pApp = this;   
   
     initially start as a window    
    m_strWindowTitle = _T( New3dApp Dx8 );   
   
   
     set up the font for drawing the current stats    
    m_pFont = new CD3DFont( _T( Arial ), 12, D3DFONT_BOLD );   
   
 DEMO CODE    
   
    m_pObjectMesh = new CD3DMesh();   
   
 END DEMO CODE    
   
}   
   
   
 Message handler    
LRESULT CNew3dAppMsgProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )   
{   
   
     just handle the close message for now    
    switch( uMsg )   
    {   
    case WM_KEYDOWN   
        {   
            switch( wParam )   
            {   
            case VK_ESCAPE   
                {   
                    DestroyWindow( hWnd );   
                    PostQuitMessage( 0 );   
                    return 0;   
                }   
            }   
        }   
    case WM_CLOSE   
        {   
            DestroyWindow( hWnd );   
            PostQuitMessage( 0 );   
            return 0;   
        }   
   
    default   
        return CD3DApplicationMsgProc( hWnd, uMsg, wParam, lParam );   
    }   
   
     pass the message back if not handled    
    return DefWindowProc( hWnd, uMsg, wParam, lParam );   
}   
   
 the create function    
HRESULT CNew3dAppCreate( HINSTANCE hInst, TCHAR  szString )   
{   
     dx8 ver    
    CD3DApplicationCreate( hInst );   
   
    return S_OK;   
       
}   
   
   
 handle the default overrides    
HRESULT CNew3dAppOneTimeSceneInit()   
{   
     set the stats options    
    SetShowStats( true );   
   
    SetLastResult( S_OK );   
    return S_OK;   
       
}   
   
 Initialise the device objects    
HRESULT CNew3dAppInitDeviceObjects()   
{      
    static bool bInitialScreen = false;   
   
    if( !bInitialScreen )   
    {   
        bInitialScreen = true;   
   
        if( FAILED( SetScreenSize( 800, 600, FALSE  ) ) )   
            return E_FAIL;   
    }   
   
    m_pFont-InitDeviceObjects( m_pd3dDevice );   
   
   
 DEMO CODE    
   
    m_vecEye.x = 0.0f;   
    m_vecEye.y = 3.0f;   
    m_vecEye.z = -100.0f;   
   
    HRESULT hResult = m_pObjectMesh-Create( m_pd3dDevice, _T( dolphin.X ) );   
    if( FAILED( hResult ) )   
        return D3DAPPERR_MEDIANOTFOUND;   
   
 END DEMO CODE    
   
    SetLastResult( hResult );   
    return hResult;   
}   
   
   
 delete any allocated device objects    
HRESULT CNew3dAppDeleteDeviceObjects()   
{   
    m_pFont-DeleteDeviceObjects();   
   
 DEMO CODE    
   
    m_pObjectMesh-Destroy();   
   
 END DEMO CODE    
   
    SetLastResult( S_OK );   
    return S_OK;   
}   
   
 render the scene    
HRESULT CNew3dAppRender()   
{   
    HRESULT hResult;   
   
       
     Begin the scene    
    hResult = m_pd3dDevice-BeginScene();   
    if( SUCCEEDED( hResult ) )   
    {   
   
 DEMO CODE    
   
        D3DXVECTOR3 vecAt( 0.0f, 0.0f, 100.0f );   
        D3DXVECTOR3 vecUp( 0.0f, 1.0f, 0.0f );   
   
         Clear the viewport    
        m_pd3dDevice-Clear( 0, NULL, D3DCLEAR_TARGET, 0x000000ff, 0L, 0L );   
   
        D3DXMATRIX matWorld;   
        D3DXMATRIX matView;   
        D3DXMATRIX matProj;   
   
         Set the Rotation speed    
        D3DXMatrixRotationY( &matWorld, timeGetTime()550.0f );   
        m_pd3dDevice-SetTransform( D3DTS_WORLD, &matWorld );   
   
        D3DXMatrixLookAtLH( &matView, &m_vecEye, &vecAt, &vecUp );   
        m_pd3dDevice-SetTransform( D3DTS_VIEW, &matView );   
   
        D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI4, 1.0f, 1.0f, -1.0f );   
        m_pd3dDevice-SetTransform( D3DTS_PROJECTION, &matProj );   
   
   
   
         tell the d3dmesh object to draw itself    
        m_pObjectMesh-Render( m_pd3dDevice );   
   
 END DEMO CODE     
   
    }   
   
     draw the stats if necassary    
    if( GetShowStats() )   
    {   
        m_pFont-DrawText( 2,  0, D3DCOLOR_ARGB(255,255,255,0), m_strFrameStats );   
        m_pFont-DrawText( 2, 20, D3DCOLOR_ARGB(255,255,255,0), m_strDeviceStats );   
    }   
   
     End the scene    
    hResult = m_pd3dDevice-EndScene();   
   
    SetLastResult( hResult );   
    return S_OK;   
}   
   
 move the frame    
HRESULT CNew3dAppFrameMove()   
{   
   
 DEMO CODE    
   
    static bool bForward = true;   
   
    if( bForward )   
    {   
        if( m_vecEye.z  2000.0f )  the distance backwards    
            bForward = false;   
        m_vecEye.x += 3.0f;  points to move to the right    
        m_vecEye.z += 10.0f;   
    }   
    else   
    {   
        if( m_vecEye.z  400.0f )  the distance forwards    
            bForward = true;   
        m_vecEye.x -= 3.0f;  points to move to the left    
        m_vecEye.z -= 10.0f;   
    }   
       
 DEMO CODE    
   
    SetLastResult( S_OK );   
    return S_OK;   
}   
   
 invalidate any device dependant objects    
HRESULT CNew3dAppInvalidateDeviceObjects()   
{   
    m_pFont-InvalidateDeviceObjects();   
   
 DEMO CODE    
   
    m_pObjectMesh-InvalidateDeviceObjects();   
   
 END DEMO CODE    
   
    SetLastResult( S_OK );   
    return S_OK;   
}   
   
   
 check for lost surfaces and if so restore them    
 Renamed from RestoreSurfaces in Dx7 to    
HRESULT CNew3dAppRestoreDeviceObjects()   
{   
    m_pFont-RestoreDeviceObjects();   
   
 DEMO CODE    
   
    m_pObjectMesh-RestoreDeviceObjects( m_pd3dDevice );   
   
   
     Lighting the world allows the textures to be seen    
     disabling this code makes the images appear as black objects.    
    m_pd3dDevice-SetRenderState( D3DRS_LIGHTING,     TRUE );   
    m_pd3dDevice-SetRenderState( D3DRS_DITHERENABLE, TRUE );   
    m_pd3dDevice-SetRenderState( D3DRS_ZENABLE,      TRUE );   
    m_pd3dDevice-SetTextureStageState( 0, D3DTSS_MAGFILTER, D3DTEXF_LINEAR );   
    m_pd3dDevice-SetTextureStageState( 0, D3DTSS_MINFILTER, D3DTEXF_LINEAR );   
   
     Setup the light    
    D3DLIGHT8 light;   
    light.Type         = D3DLIGHT_DIRECTIONAL;   
    light.Diffuse.r    = light.Diffuse.g  = light.Diffuse.b  = 1.0f;   
    light.Specular.r   = light.Specular.g = light.Specular.b = 0.0f;   
    light.Ambient.r    = light.Ambient.g  = light.Ambient.b  = 0.3f;   
    light.Position     = D3DXVECTOR3( 0.0f, 0.0f, 0.0f );   
    D3DXVec3Normalize( (D3DXVECTOR3)&light.Direction, &D3DXVECTOR3( 0.3f, -1.0f, 1.0f ) );   
    light.Attenuation0 = light.Attenuation1 = light.Attenuation2 = 0.0f;   
    light.Range        = sqrtf(FLT_MAX);   
    m_pd3dDevice-SetLight(0, &light );   
    m_pd3dDevice-LightEnable(0, TRUE );   
   
 END DEMO CODE    
   
    SetLastResult( S_OK );   
    return S_OK;   
}   
   
 clean up before exiting    
HRESULT CNew3dAppFinalCleanup()   
{   
    if( m_pFont )   
    {   
        delete m_pFont;   
        m_pFont = NULL;   
    }   
   
 DEMO CODE    
   
    if( m_pObjectMesh )   
    {   
        delete m_pObjectMesh;   
        m_pObjectMesh = NULL;   
    }   
   
 END DEMO CODE    
   
   
    SetLastResult( S_OK );   
    return S_OK;   
}   
   
 set the screen size for the current app    
HRESULT CNew3dAppSetScreenSize( int nHoriz, int nVert, BOOL bWindowed, D3DFORMAT d3dFormat )   
{   
    HRESULT hResult = S_OK;   
    int nWidth, nHeight;   
   
     Get access to the newly selected adapter, device, and mode    
    DWORD dwDevice;   
    dwDevice  = m_Adapters[m_dwAdapter].dwCurrentDevice;   
   
    for( int i=0; i( int )m_Adapters[ m_dwAdapter ].devices[ dwDevice ].dwNumModes; i++ )   
    {   
        if( m_Adapters[ m_dwAdapter ].devices[ dwDevice ].modes[ i ].Format == d3dFormat )   
        {   
            nWidth = ( int )m_Adapters[ m_dwAdapter ].devices[ dwDevice ].modes[ i ].Width;   
            nHeight = ( int )m_Adapters[ m_dwAdapter ].devices[ dwDevice ].modes[ i ].Height;   
   
            if( nWidth == nHoriz && nHeight == nVert )   
            {   
                m_Adapters[ m_dwAdapter ].devices[ dwDevice ].dwCurrentMode = i;   
                m_Adapters[ m_dwAdapter ].devices[ dwDevice ].bWindowed = bWindowed;   
                m_bWindowed = bWindowed;    
                break;   
            }   
        }   
    }   
   
     Release all scene objects that will be re-created for the new device    
    InvalidateDeviceObjects();   
    DeleteDeviceObjects();   
   
     Release display objects, so a new device can be created    
    if( m_pd3dDevice-Release()  0L )   
    {   
         if greater than 0 the com reference count is out of balance and it's a good idea to quit before code go boom    
        return DisplayErrorMsg( D3DAPPERR_NONZEROREFCOUNT, MSGERR_APPMUSTEXIT );   
    }   
   
     Inform the display class of the change. It will internally    
     re-create valid surfaces, a d3ddevice, etc.    
    hResult = Initialize3DEnvironment();   
    if( FAILED( hResult ) )   
        return DisplayErrorMsg( hResult, MSGERR_APPMUSTEXIT );   
   
   
    SetLastResult( hResult );   
    return hResult;   
}   
   